<?php
  define('EQUATION_FG_COLOR_RED', 0);
  define('EQUATION_FG_COLOR_GREEN', 0);
  define('EQUATION_FG_COLOR_BLUE', 0);
  define('EQUATION_BG_COLOR_RED', 255);
  define('EQUATION_BG_COLOR_GREEN', 255);
  define('EQUATION_BG_COLOR_BLUE', 255);

  class equation
  {
    var $image;
    var $eqn;
    var $tokens;
    var $size = 25; // font size
    var $vcenter;   // vertical coordinate to be considered the center of the equation.
    var $postion;   // position array. indexes match indexes of $tokens.
                    // foreach($position as $index=>$coords), $coords = array($x, $y, $width, $height)

    function equation($eqn, $size=0)
    {
      if($size > 0) $this->size = $size;
      if(is_array($eqn))
      {
        $this->tokens = $eqn;
        $this->eqn = '';
      }
      else
      {
        $this->eqn = $eqn;
        $this->get_tokens();
      }

      $this->tokens = $this->parse();
      $this->draw();
    }

    function set_size($size)
    {
      $hold_size = $this->size;
      if($size != $this->size)
      {
        $ratio = $size / $this->size;
        $this->size = $size;
        for($i = 0; $i < count($this->tokens); $i++)
          if(is_object($this->tokens[$i]))
            $this->tokens[$i]->set_size($this->tokens[$i]->size * $ratio);
        $this->draw();
      }
      $this->size = $hold_size;
    }

    function get_tokens()
    {
      $e = str_replace('_', ' _ ', $this->eqn);
      $e = str_replace("'", ' prime ', $e);
      $e = str_replace('"', ' prime prime ', $e);
      $t = token_get_all("<?php \$z=$e ?".'>');
      $this->tokens = array();
      for($i = array_search('=', $t) + 1; $i < count($t) - 1; $i++)
      {
        if(is_array($t[$i]))
          $t[$i] = $t[$i][1];
        if($t[$i] == '+' && $t[$i+1] == '/' && $t[$i+2] == '-')
        {
          $t[$i] = 'pm';
          $t[$i+1] = '';
          $t[$i+2] = '';
        }
        elseif($t[$i] == '<=')
          $t[$i] = 'le';
        elseif($t[$i] == '=' && $t[$i+1] == '<')
        {
          $t[$i] = 'le';
          $t[$i+1] = '';
        }
        elseif($t[$i] == '!=')
          $t[$i] = 'ne';
        elseif($t[$i] == '<>')
          $t[$i] = 'ne';
        elseif($t[$i] == '>=')
          $t[$i] = 'ge';
        elseif($t[$i] == '=>')
          $t[$i] = 'ge';
        elseif($t[$i] == '--')
        {
          $t[$i] = '-';
          $t[$i+1] = '-' . $t[$i+1];
        }
        elseif($t[$i] == '++')
          $t[$i] = '+';
        elseif($t[$i] == '-')
        {
          if($t[$i - 1] == '^' || $t[$i - 1] == '_' || $t[$i - 1] == '*' || $t[$i - 1] == '.' || $t[$i - 1] == '/' || $t[$i - 1] == '+' || $t[$i - 1] == '(')
          {
            $t[$i] = '';
            if(is_array($t[$i+1]))
              $t[$i+1][1] = '-' . $t[$i+1][1];
            else
              $t[$i+1] = '-' . $t[$i+1];
          }
        }
        elseif($t[$i] == 'prime')
          $t[$i] = "'";
        if(trim($t[$i]) != '')
          $this->tokens[] = trim($t[$i]);
      }
    }

    function render($text, $size=0, $angle=0)
    {
      $chars = array('alpha'=>'a','beta'=>'b','gamma'=>'g','delta'=>'d','epsilon'=>'e','zeta'=>'z','eta'=>'h','theta'=>'q',
			'iota'=>'i','kappa'=>'k','lambda'=>'l','mu'=>'m','nu'=>'n','xi'=>'x','omikron'=>'o','pi'=>'p','rho'=>'r',
			'sigma'=>'s','tau'=>'t','upsilon'=>'u','phi'=>'f','chi'=>'c','psi'=>'y','omega'=>'w',
			'forall'=>chr(34),		// forall
			'exists'=>chr(36),		// there exists
			'backepsilon'=>chr(39),		// back epsilon
			'therefore'=>chr(92),		// therefore
			'ortho'=>chr(94),		// is orthogonal
			'le'=>chr(163),			// less than or equal to
			'inf'=>chr(165),		// infinity
			'infinity'=>chr(165),		// infinity
			'leftright'=>chr(171),		// left right arrow
			'left'=>chr(172),		// left arrow
			'up'=>chr(173),			// up arrow
			'right'=>chr(174),		// right arrow
			'down'=>chr(175),		// down arrow
			'pm'=>chr(177),			// plus or minus
			'ge'=>chr(179),			// greater than or equal to
			'times'=>chr(180),		// times
			'cross'=>chr(180),		// cross product
			'prop'=>chr(181),		// proportional to
			'partial'=>chr(182),		// partial derivative or set margin
			'dot'=>chr(183),		// dot
			'divide'=>chr(184),		// divide symbol
			'div'=>chr(184),		// divide symbol
			'ne'=>chr(185),			// not equal to
			'neq'=>chr(185),		// not equal to
			'congr'=>chr(186),		// congruent
			'approx'=>chr(187),		// approximates
			'aleph'=>chr(192),		// aleph
			'im'=>chr(193),			// set of imaginary numbers
			'real'=>chr(194),		// set of real numbers
			'wp'=>chr(195),			// p function (wp), Weierstrass p
			'otimes'=>chr(196),		// otimes
			'oplus'=>chr(197),		// oplus
			'null'=>chr(198),		// null set, empty
			'empty'=>chr(198),		// null set, empty
			'intersect'=>chr(199),		// intersection of
			'union'=>chr(200),		// union of
			'supset'=>chr(201),		// superset of
			'supseteq'=>chr(202),		// proper superset of
			'notsubset'=>chr(203),		// not subset of
			'propsubset'=>chr(204),		// proper subset of
			'subset'=>chr(205), 		// subset of
			'element'=>chr(206),		// element of, in
			'in'=>chr(206),			// element of, in
			'notelement'=>chr(207),		// not element of, not in
			'notin'=>chr(207),		// not element of, not in
			'angle'=>chr(208),		// angle
			'nabla'=>chr(209),		// nabla
			'not'=>chr(216),		// logical not
			'and'=>chr(217),		// logical and
			'or'=>chr(218),			// logical or
			'equiv'=>chr(219),		// logically equivalent
			'doubleleftright'=>chr(219),	// double left right
			'doubleleft'=>chr(220),		// double left
			'doubleup'=>chr(221),		// double up
			'doubleright'=>chr(222),	// double right, implies
			'implies'=>chr(222),		// double right, implies
			'doubledown'=>chr(223)		// double down
		);

      $font = 'times.ttf';
      if(!is_numeric($text))
      {
        if(isset($chars[$text]))
        {
          $text = $chars[$text];
          $font = 'symbol.ttf';
        }
        elseif(isset($chars[strtolower($text)]))
        {
          $text = strtoupper($chars[strtolower($text)]);
          $font = 'symbol.ttf';
        }
        elseif(is_alpha($text))
          $font = 'timesi.ttf';
      }

      if($size == 0) $size = $this->size;

      if($text == '.')
        $htext = $text;
      else
        $htext = 'dg'.$text;

      $hdim = ImageTTFBBox($size, $angle, $font, $htext);
      $wdim = ImageTTFBBox($size, $angle, $font, $text); 
      $dx = max($wdim[2], $wdim[4]) - min($wdim[0], $wdim[6]) + $size / 4;
      $dy = max($hdim[1], $hdim[3]) - min($hdim[5], $hdim[7]) + $size / 4;

      $img = ImageCreate($dx, $dy);
      ImageColorAllocate($img, EQUATION_BG_COLOR_RED, EQUATION_BG_COLOR_GREEN, EQUATION_BG_COLOR_BLUE);
      $txtc = ImageColorAllocate($img, EQUATION_FG_COLOR_RED, EQUATION_FG_COLOR_GREEN, EQUATION_FG_COLOR_BLUE); 
      ImageTTFText($img, $size, $angle, 0, -min($hdim[5], $hdim[7]), $txtc, $font, $text); 

      return $img;
    }

    function parse()
    {
      if(count($this->tokens) <= 3) return $this->tokens;
      $ret = array();
      $opens = array();
      for($i = 0; $i < count($this->tokens); $i++)
      {
        if(!is_object($this->tokens[$i]) && ($this->tokens[$i] == '(' || $this->tokens[$i] == '{'))
          array_push($opens, $i);
        elseif(!is_object($this->tokens[$i]) && ($this->tokens[$i] == ')' || $this->tokens[$i] == '}'))
        {
          $start = array_pop($opens);
          if(count($opens) == 0)
          {
            $sub = array_slice($this->tokens, $start + 1, $i - $start - 1);
            if($this->tokens[$i] == ')')
              $ret[] = new equation(array('(', new equation($sub, $this->size), ')'), $this->size);
            else
              $ret[] = new equation($sub, $this->size);
          }
        }
        elseif(count($opens) == 0)
          $ret[] = $this->tokens[$i];
      }
      return $this->femdas($ret);
    }

    function op_token($tokens, $op)
    {
      do
      {
        $changes = false;
        if(count($tokens) <= 3) return $tokens;
        $ret = array();
        for($i = 0; $i < count($tokens); $i++)
        {
          if(!$changes && $i < count($tokens) - 2 && !is_object($tokens[$i+1]) && $tokens[$i+1] == $op)
          {
            $ret[] = new equation(array($tokens[$i], $tokens[$i+1], $tokens[$i+2]), $this->size);
            $i += 2;
            $changes = true;
          }
          else
            $ret[] = $tokens[$i];
        }
        $tokens = $ret;
      }
      while($changes);
      return $ret;
    }

    function fn_token($tokens, $fn, $argc)
    {
      if(count($tokens) <= $argc + 1) return $tokens;
      $ret = array();
      for($i = 0; $i < count($tokens); $i++)
      {
        if($i < count($tokens) - $argc && !is_object($tokens[$i]) && $tokens[$i] == $fn)
        {
          $a = array();
          for($j = $i; $j <= $i + $argc; $j++)
            $a[] = (!is_object($tokens[$j]) && $tokens[$j] == '_') ? '' : $tokens[$j];
          $ret[] = new equation($a, $this->size);
          $i += $argc;
        }
        else
          $ret[] = (!is_object($tokens[$i]) && $tokens[$i] == '_') ? '' : $tokens[$i];
      }
      return $ret;
    }

    function femdas($t) // (f)unctions, (e)xponents, (m)ultiply, (d)ivide, (a)dd, (s)ubtract 
    {
      $t = $this->op_token($t, 'over');
      $t = $this->fn_token($t, 'sqrt', 1);
      $t = $this->fn_token($t, 'bar', 1);
      $t = $this->fn_token($t, 'hat', 1);
      $t = $this->fn_token($t, 'root', 2);
      $t = $this->fn_token($t, 'int', 3);
      $t = $this->fn_token($t, 'sum', 3);
      $t = $this->op_token($t, '^');
      $t = $this->op_token($t, '_');
      $t = $this->op_token($t, '*');
      $t = $this->op_token($t, '.');
      $t = $this->op_token($t, '/');
      $t = $this->op_token($t, '+');
      $t = $this->op_token($t, '-');
      return $t;
    }

    function get_token_array()
    {
      $ret = array();
      foreach($this->tokens as $key=>$token)
      {
        if(is_object($token))
          $ret[$key] = $token->get_token_array();
        else
          $ret[$key] = $token;
      }
      return $ret;
    }

    function draw()
    {
      switch(count($this->tokens))
      {
        case 1:
          if(is_object($this->tokens[0]))
          {
            $this->tokens[0]->set_size($this->size);
            $this->tokens[0]->draw();
            $this->image = $this->tokens[0]->image;
          }
          else
          {
            $this->image = $this->render($this->tokens[0]);
            $this->vcenter = imagesy($this->image) / 2;
          }
          break;
        case 2:
          if(!is_object($this->tokens[0]) && $this->tokens[0] == 'sqrt')
            $this->root($this->tokens[1]);
          elseif(!is_object($this->tokens[0]) && $this->tokens[0] == 'bar')
            $this->bar($this->tokens[1]);
          elseif(!is_object($this->tokens[0]) && $this->tokens[0] == 'hat')
            $this->hat($this->tokens[1]);
          else
            $this->horizontal();
          break;
        case 3:
          if(is_object($this->tokens[1]))
            $this->horizontal();
          elseif(!is_object($this->tokens[0]) && $this->tokens[0] == 'root')
            $this->root($this->tokens[2], $this->tokens[1]);
          else switch($this->tokens[1])
          {
            case '/':
              $this->over(1);
              break;
            case 'over':
              $this->over();
              break;
            case '^':
              $this->exponent();
              break;
            case '_':
              $this->subscript();
              break;
            default:
              $this->horizontal();
              break;
          }
          break;
        case 4:
          if($this->tokens[0] == 'int')
            $this->integral();
          elseif($this->tokens[0] == 'sum')
            $this->summation();
          else
            $this->horizontal();
          break;
        default:
          $this->horizontal();
          break;
      }
    }

    function summation()
    {
      static $ratio = .5;

      if(!is_object($this->tokens[2]))
        $ai = $this->render($this->tokens[2], $this->size * $ratio);
      else
      {
        $this->tokens[2]->set_size($this->size * $ratio);
        $this->tokens[2]->draw();
        $ai = $this->tokens[2]->image;
      }
      if(!is_object($this->tokens[1]))
        $bi = $this->render($this->tokens[1], $this->size * $ratio);
      else
      {
        $this->tokens[1]->set_size($this->size * $ratio);
        $this->tokens[1]->draw();
        $bi = $this->tokens[1]->image;
      }
      if(!is_object($this->tokens[3]))
        $ci = $this->render($this->tokens[3]);
      else
        $ci = $this->tokens[3]->image;

      $swidth = max(imagesx($ai), imagesx($bi), imagesy($ci) * .75);
      $height = imagesy($ai) + imagesy($bi) + imagesy($ci);
      $width = $swidth + imagesx($ci);
      $this->image = ImageCreate($width, $height);
      $this->vcenter = imagesy($ai) / 2 + ($height - imagesy($bi)) / 2;

      $this->image = ImageCreate($width, $height);
      ImageColorAllocate($this->image, EQUATION_BG_COLOR_RED, EQUATION_BG_COLOR_GREEN, EQUATION_BG_COLOR_BLUE);
      $txtc = ImageColorAllocate($this->image, EQUATION_FG_COLOR_RED, EQUATION_FG_COLOR_GREEN, EQUATION_FG_COLOR_BLUE);

      $this->place_token(2, $ai, ($swidth - imagesx($ai)) / 2, 0);
      $this->place_token(1, $bi, ($swidth - imagesx($bi)) / 2, $height - imagesy($bi));
      $this->place_token(3, $ci, $swidth, $this->vcenter - imagesy($ci) / 2);

      imageline($this->image, 0, imagesy($ai) + 1, $swidth - 1, imagesy($ai) + 1, $txtc);
      imageline($this->image, 0, imagesy($ai) + 1, $swidth / 2, $this->vcenter, $txtc);
      imageline($this->image, 0, $height - imagesy($bi) - 1, $swidth / 2, $this->vcenter, $txtc);
      imageline($this->image, 0, $height - imagesy($bi) - 1, $swidth - 1, $height - imagesy($bi) - 1, $txtc);
    }

    function integral()
    {
      static $ratio = .33;

      if(!is_object($this->tokens[2]))
        $ai = $this->render($this->tokens[2], $this->size * $ratio);
      else
      {
        $this->tokens[2]->set_size($this->size * $ratio);
        $this->tokens[2]->draw();
        $ai = $this->tokens[2]->image;
      }
      if(!is_object($this->tokens[1]))
        $bi = $this->render($this->tokens[1], $this->size * $ratio);
      else
      {
        $this->tokens[1]->set_size($this->size * $ratio);
        $this->tokens[1]->draw();
        $bi = $this->tokens[1]->image;
      }
      if(!is_object($this->tokens[3]))
        $ci = $this->render($this->tokens[3]);
      else
        $ci = $this->tokens[3]->image;

      $height = imagesy($ai) + imagesy($bi) + imagesy($ci);
      $width = $height / 4 + 5 + max(imagesx($ai), imagesx($bi)) + imagesx($ci);
      $this->vcenter = $height / 2;

      $this->image = ImageCreate($width, $height);
      ImageColorAllocate($this->image, EQUATION_BG_COLOR_RED, EQUATION_BG_COLOR_GREEN, EQUATION_BG_COLOR_BLUE);
      $txtc = ImageColorAllocate($this->image, EQUATION_FG_COLOR_RED, EQUATION_FG_COLOR_GREEN, EQUATION_FG_COLOR_BLUE);

      $this->place_token(2, $ai, $height / 4 + 5, 0);
      $this->place_token(1, $bi, $height / 4 + 5, $height - imagesy($bi));
      $this->place_token(3, $ci, $width - imagesx($ci), ($height - imagesy($ci)) / 2);

      imageline($this->image, $height / 8, $height / 8, $height / 8, 7 * $height / 8, $txtc);
      imagearc($this->image, $height / 4, $height / 8, $height / 4, $height / 4, 180, 270, $txtc);
      imagearc($this->image, 0, 7 * $height / 8, $height / 4, $height / 4, 0, 90, $txtc);
    }

    function exponent()
    {
      static $ratio = .66;
      if(!is_object($this->tokens[0]))
        $ai = $this->render($this->tokens[0]);
      else
        $ai = $this->tokens[0]->image;
      if(!is_object($this->tokens[2]))
        $bi = $this->render($this->tokens[2], $this->size * $ratio);
      else
      {
        $this->tokens[2]->set_size($this->size * $ratio);
        $this->tokens[2]->draw();
        $bi = $this->tokens[2]->image;
      }
      $width = imagesx($ai) + imagesx($bi);
      $height = ceil(imagesy($ai) + imagesy($bi) / 2);

      if(is_object($this->tokens[0]))
        $this->vcenter = $height + $this->tokens[0]->vcenter - imagesy($ai);
      else
        $this->vcenter = $height - imagesy($ai) / 2;

      $this->image = ImageCreate($width, $height);

      $this->place_token(0, $ai, 0, $height - imagesy($ai));
      $this->place_token(2, $bi, imagesx($ai), 0);
    }

    function subscript()
    {
      static $ratio = .66;
      if(!is_object($this->tokens[0]))
        $ai = $this->render($this->tokens[0]);
      else
        $ai = $this->tokens[0]->image;
      if(!is_object($this->tokens[2]))
        $bi = $this->render($this->tokens[2], $this->size * $ratio);
      else
      {
        $this->tokens[2]->set_size($this->size * $ratio);
        $this->tokens[2]->draw();
        $bi = $this->tokens[2]->image;
      }
      $width = imagesx($ai) + imagesx($bi);
      $height = ceil(imagesy($ai) + imagesy($bi) / 5);

      $this->vcenter = imagesy($ai) / 2;

      $this->image = ImageCreate($width, $height);

      $this->place_token(0, $ai, 0, 0);
      $this->place_token(2, $bi, imagesx($ai), $height - imagesy($bi));
    }

    function root($a, $r=' ')
    {
      static $ratio = .5;

      if(!is_object($a))
      {
        $ai = $this->render($a);
        $this->vcenter = imagesy($ai) / 2 + 4;
      }
      else
      {
        $ai = $a->image;
        $this->vcenter = $a->vcenter + 4;
      }
      if(!is_object($r))
        $ri = $this->render($r, $this->size * $ratio);
      else
      {
        $r->set_size($this->size * $ratio);
        $ri = $r->image;
      }

      $width = imagesx($ai) + imagesx($ri) + 20;
      $height = imagesy($ai) + 4;

      $this->image = ImageCreate($width, $height);
      ImageColorAllocate($this->image, EQUATION_BG_COLOR_RED, EQUATION_BG_COLOR_GREEN, EQUATION_BG_COLOR_BLUE);
      $txtc = ImageColorAllocate($this->image, EQUATION_FG_COLOR_RED, EQUATION_FG_COLOR_GREEN, EQUATION_FG_COLOR_BLUE);

      $this->place_token(1, $ai, imagesx($ri) + 15, 4);
      $this->place_token(0, $ri, 0, 0);
      imageline($this->image, imagesx($ri) + 10, 0, $width - 5, 0, $txtc);
      imageline($this->image, imagesx($ri) + 10, 0, imagesx($ri), $height, $txtc);
      imageline($this->image, imagesx($ri), $height, imagesx($ri) - 10, 3 * $height / 4, $txtc);
    }

    function bar($a)
    {
      if(!is_object($a))
      {
        $ai = $this->render($a);
        $this->vcenter = imagesy($ai) / 2 + 2;
      }
      else
      {
        $ai = $a->image;
        $this->vcenter = $a->vcenter + 2;
      }

      $width = imagesx($ai) + imagesx($ri);
      $height = imagesy($ai) + 2;

      $this->image = ImageCreate($width, $height);
      ImageColorAllocate($this->image, EQUATION_BG_COLOR_RED, EQUATION_BG_COLOR_GREEN, EQUATION_BG_COLOR_BLUE);
      $txtc = ImageColorAllocate($this->image, EQUATION_FG_COLOR_RED, EQUATION_FG_COLOR_GREEN, EQUATION_FG_COLOR_BLUE);

      $this->place_token(1, $ai, 0, 2);
      imageline($this->image, 5, 0, $width - 5, 0, $txtc);
    }

    function hat($a)
    {
      if(!is_object($a))
      {
        $ai = $this->render($a);
        $this->vcenter = imagesy($ai) / 2 + 6;
      }
      else
      {
        $ai = $a->image;
        $this->vcenter = $a->vcenter + 6;
      }

      $width = imagesx($ai) + imagesx($ri);
      $height = imagesy($ai) + 6;

      $this->image = ImageCreate($width, $height);
      ImageColorAllocate($this->image, EQUATION_BG_COLOR_RED, EQUATION_BG_COLOR_GREEN, EQUATION_BG_COLOR_BLUE);
      $txtc = ImageColorAllocate($this->image, EQUATION_FG_COLOR_RED, EQUATION_FG_COLOR_GREEN, EQUATION_FG_COLOR_BLUE);

      $this->place_token(1, $ai, 0, 6);
      imageline($this->image, 5, 6, $width / 2, 0, $txtc);
      imageline($this->image, $width / 2, 0, $width - 5, 6, $txtc);
    }

    function over($bar=0)
    {
      static $ratio = .75;
      if(!is_object($this->tokens[0]))
        $ai = $this->render($this->tokens[0], $this->size * $ratio);
      else
      {
        $this->tokens[0]->set_size($this->size * $ratio);
        $ai = $this->tokens[0]->image;
      }
      if(!is_object($this->tokens[2]))
        $bi = $this->render($this->tokens[2], $this->size * $ratio);
      else
      {
        $this->tokens[2]->set_size($this->size * $ratio);
        $bi = $this->tokens[2]->image;
      }
      $width = max(imagesx($ai), imagesx($bi));
      $height = imagesy($ai) + imagesy($bi) + $this->size / 4;

      $this->image = ImageCreate($width + 5, $height);
      ImageColorAllocate($this->image, EQUATION_BG_COLOR_RED, EQUATION_BG_COLOR_GREEN, EQUATION_BG_COLOR_BLUE);
      $txtc = ImageColorAllocate($this->image, EQUATION_FG_COLOR_RED, EQUATION_FG_COLOR_GREEN, EQUATION_FG_COLOR_BLUE);

      $this->vcenter = imagesy($ai) + $this->size / 8;

      $this->place_token(0, $ai, ($width - imagesx($ai)) / 2, 0);
      if($bar) imageline($this->image, 0, $this->vcenter, $width, $this->vcenter, $txtc);
      $this->place_token(2, $bi, ($width - imagesx($bi)) / 2, imagesy($ai) + $this->size / 4);
    }

    function horizontal()
    {
      $width = 0;
      $height = 0;
      $p = 0;
      $above = 0;
      $below = 0;
      for($i = 0; $i < count($this->tokens); $i++)
      {
        if(is_object($this->tokens[$i]))
        {
          $img[$i] = $this->tokens[$i]->image;
          $cen[$i] = $this->tokens[$i]->vcenter;
          $above = max($cen[$i], $above);
          $below = max(imagesy($img[$i]) - $cen[$i], $below);
        }
        else if($this->tokens[$i] != '(' && $this->tokens[$i] != ')')
        {
          $img[$i] = $this->render($this->tokens[$i]);
          $cen[$i] = imagesy($img[$i]) / 2;
          $above = max($cen[$i], $above);
          $below = max($cen[$i], $below);
        }

        if(is_object($this->tokens[$i]) || ($this->tokens[$i] != '(' && $this->tokens[$i] != ')'))
          $width += imagesx($img[$i]);
        else
          $p++;
      }

      $this->vcenter = $above;
      $height = $above + $below;

      if($p)
      {
        $po = $this->parenthesis($height, '(');
        $pc = $this->parenthesis($height, ')');
        
        $width = 0;
        for($i = 0; $i < count($this->tokens); $i++)
        {
          if(!isset($img[$i]))
          {
            if($this->tokens[$i] == '(')
              $img[$i] = $po;
            else
              $img[$i] = $pc;
            $cen[$i] = $above; //imagesy($img[$i]) / 2;
          }
          $width += imagesx($img[$i]);
        }
      }

      $this->image = ImageCreate($width, $height);

      $pos = 0;
      for($i = 0; $i < count($img); $i++)
      {
        $this->place_token($i, $img[$i], $pos, $above - $cen[$i]);
        $pos += imagesx($img[$i]);
      }
    }

    function parenthesis($height, $style)
    {
      $img = ImageCreate($height / 6 + 2, $height);
      ImageColorAllocate($img, EQUATION_BG_COLOR_RED, EQUATION_BG_COLOR_GREEN, EQUATION_BG_COLOR_BLUE);
      $txtc = ImageColorAllocate($img, EQUATION_FG_COLOR_RED, EQUATION_FG_COLOR_GREEN, EQUATION_FG_COLOR_BLUE);

      if($style == '(')
      {
        imageline($img, 0, $height / 8, 0, 7 * $height / 8, $txtc);
        imagearc($img, $height / 8, $height / 8, $height / 4, $height / 4, 180, 270, $txtc);
        imagearc($img, $height / 8, 7 * $height / 8, $height / 4, $height / 4, 90, 180, $txtc);
      }
      else if($style == ')')
      {
        imageline($img, $height / 8, $height / 8, $height / 8, 7 * $height / 8, $txtc);
        imagearc($img, 0, $height / 8, $height / 4, $height / 4, 270, 360, $txtc);
        imagearc($img, 0, 7 * $height / 8, $height / 4, $height / 4, 0, 90, $txtc);
      }
      return $img;
    }

    function place_token($index, $image, $x, $y)
    {
      $width = imagesx($image);
      $height = imagesy($image);
      $x = round($x);
      $y = round($y);
      ImageCopy($this->image, $image, $x, $y, 0, 0, $width, $height);
      $this->position[$index] = array($x, $y, $width, $height);
    }

    function token_locations()
    {
      $ret = array();
      foreach($this->position as $index=>$coords)
      {
        if(is_object($this->tokens[$index]))
        {
          $t = $this->tokens[$index];
          foreach($t->token_locations() as $rec)
            $ret[] = array($rec[0], $rec[1] + $coords[0], $rec[2] + $coords[1], $rec[3], $rec[4]);
        }
        else
          $ret[] = array($this->tokens[$index], $coords[0], $coords[1], $coords[2], $coords[3]);
      }
      return $ret;
    }
  }

  function is_alpha($text)
  {
    $text = strtolower($text);
    for($i = strlen($text) - 1; $i >= 0; $i--)
      if(ord('a') > ord($text{$i}) || ord($text{$i}) > ord('z'))
        return false;
    return true;
  }
?>
